/*
##################################################################################################
#
#   Travelling Salesman Problem with Kohonen network
#   Sommersemester 1996 
#   Neuronale Netze & ihre Anwendungen
#   Michael Ratz, Johannes Beck 
#
##################################################################################################
*/

#include "graph.h"

graphic::graphic(int size)
	{
	p = new XmTLib(size, size, 1);
	p->SetAutomovesOF();  // very important for speed !!
	p->SetMoveMode(0);    // improve speed
	lambda = size * 4 / 5;
	offset = size / 10;
	deleteCounter = 0;
	}

graphic::~graphic()
	{
	p->StopSim();  // kill window
	}

int graphic::draw_line(float x1,float y1, float x2, float y2)
	{
	return p->CreateStaticLine( 
			int(lambda*x1 + offset),int(lambda*y1 + offset),
   			int(lambda*x2 + offset),int(lambda*y2 + offset));
	}

void graphic::delete_line(int line_id)
	{
	if (line_id)
		p->KillObj(line_id);
	}

