/*
##################################################################################################
#
#   Travelling Salesman Problem with Kohonen network
#   Sommersemester 1996 
#   Neuronale Netze & ihre Anwendungen
#   Michael Ratz, Johannes Beck 
#
##################################################################################################
*/

#include <stdio.h>
#include <stdlib.h>

#include "tsp_parser.h"

#define NUMBER_OF_CITIES "!CITIES"
#define COORDINATES      "!COORDINATES"
#define RANDOM 		 "!RANDOM_COORDINATES"
#define DECREASE      	 "!DECREASE"
#define LEARNINGRATE 	 "!LEARNING_RATE"
#define CYCLES      	 "!CYCLES"
#define UPDATE      	 "!UPDATE"
#define SCREEN 		 "!SCREENSIZE"

/* functions prototypes	*/
simulator *readMap(char *fileName)
{
	char      line[256];
	FILE      *file;
	float     x,y;	
        sample    *neu, *last;
	simulator *sim;
	int       i;

	sim = new simulator();
	if (!sim) return NULL;
	sim->cycle    = 0;
	sim->createFirstNeuron();

	file=fopen(fileName,"r");
	if (!file)
		{
		fprintf(stderr,"File %s could not be opened\n",fileName);
		exit(-1);
		}
	do 	{
		fscanf(file,"%s",line);
		} while (strcmp(line,NUMBER_OF_CITIES));
	fscanf(file,"%d",&sim->N);
	do 	{
		fscanf(file,"%s",line);		
		} while (strcmp(line,COORDINATES) && strcmp(line,RANDOM));
	if (strcmp(line,COORDINATES)==0)
	   {
    	   neu = sim->city = NULL;
	   for (i=1; i<=sim->N; i++)
		{
		fscanf(file,"%f",&x);		
		fscanf(file,"%f",&y);		
		last = neu;
		neu = new sample;
		if (!neu) return NULL;
		neu->next = NULL;
		neu->x    = x;
		neu->y    = y;
		if (!sim->city)
			sim->city=neu;
		if (last)
			last->next=neu;
		}
           neu->next=sim->city;
	   }
	else
	   sim->createRandomCities();	

	do 	{
		fscanf(file,"%s",line);
		} while (strcmp(line,CYCLES));
	fscanf(file,"%d",&sim->maxCycles);
	do 	{
		fscanf(file,"%s",line);
		} while (strcmp(line,LEARNINGRATE));
	fscanf(file,"%f",&sim->G);
	do 	{
		fscanf(file,"%s",line);
		} while (strcmp(line,DECREASE));
	fscanf(file,"%f",&sim->alpha);
	do      {
                fscanf(file,"%s",line);
                } while (strcmp(line,UPDATE));
	fscanf(file,"%d",&sim->update);	
	do      {
                fscanf(file,"%s",line);
                } while (strcmp(line,SCREEN));
	fscanf(file,"%d",&sim->screensize);
	fclose(file);
     return sim;
}
